# Apache Tomcat 7

Version 7.0.4, Oct 14 2010

Links

- Docs Home
- Config Ref. Home

Top Level Elements

- Server
- Service

Executors

- Executor

Connectors

- HTTP
- AJP

Containers

- Context
- Engine
- Host
- Cluster

Nested Components

- Filter
- Global Resources
- JarScanner
- Listeners
- Loader
- Manager
- Realm
- Resources
- Valve

Cluster Elements

- Cluster
- Manager
- Channel
- Channel/Membership
- Channel/Sender
- Channel/Receiver
- Channel/Interceptor
- Valve
- Deployer
- ClusterListener

Global Settings

- System properties

# The AJP Connector

Table of Contents

> - Introduction
> - Attributes
>   1. Common Attributes
>   2. Standard Implementations
>   3. BIO specific configuration
>   4. APR/native specific configuration
> - Nested Components
> - Special Features
>   1. Proxy Support

Introduction

> The AJP Connector element represents a Connector component that communicates with a web connector via the `AJP` protocol. This is used for cases where you wish to invisibly integrate Tomcat into an existing (or new) Apache installation, and you want Apache to handle the static content contained in the web application, and/or utilize Apache's SSL processing.

> This connector supports load balancing when used in conjunction with the `jvmRoute` attribute of the Engine.

> The native connectors supported with this Tomcat release are:

> - JK 1.2.x with any of the supported servers
> - mod_proxy on Apache httpd 2.x (included by default in Apache HTTP Server 2.2), with AJP enabled: see the httpd docs for details.

> Other native connectors supporting AJP may work, but are no longer supported.

Attributes

> Common Attributes

> > All implementations of Connector support the following attributes:

> > Attribute | Description
> > --- | ---
> > `allowTrace` | A boolean value which can be used to enable or disable the TRACE HTTP method. If not specified, this attribute is set to false.
> > `asyncTimeout` | The default timeout for asynchronous requests in milliseconds. If not specified, this attribute is set to 10000 (10 seconds).
> > `enableLookups` | Set to `true` if you want calls to `request.getRemoteHost()` to perform DNS lookups in order to return the actual host name of the remote client. Set to `false` to skip the DNS lookup and return the IP address in String form instead (thereby improving performance). By default, DNS lookups are enabled.
> > `maxPostSize` | The maximum size in bytes of the POST which will be handled by the container FORM URL parameter parsing. The limit can be disabled by setting this attribute to a value less than or equal to 0. If not specified, this attribute is set to 2097152 (2 megabytes).

> > `maxSavePostSize`

> > The maximum size in bytes of the POST which will be saved/buffered by the container during FORM or CLIENT-CERT authentication. For both types of authentication, the POST will be saved/buffered before the user is authenticated. For CLIENT-CERT authentication, the POST is buffered for the duration of the SSL handshake and the buffer emptied when the request is processed. For FORM authentication the POST is saved whilst the user is re-directed to the login form and is retained until the user successfully authenticates or the session associated with the authentication request expires. The limit can be disabled by setting this attribute to -1. Setting the attribute to zero will disable the saving of POST data during authentication. If not specified, this attribute is set to 4096 (4 kilobytes).

> > `port` | The TCP port number on which this Connector will create a server socket and await incoming connections. Your operating system will allow only one server application to listen to a particular port number on a particular IP address.

> > `protocol`

> > Sets the protocol to handle incoming traffic. To configure an AJP connector this must be specified. If no value for protocol is provided, an HTTP connector rather than an AJP connector will be configured.
> > The standard protocol value for an AJP connector is `AJP/1.3` which uses an auto-switching mechanism to select either a Java based connector or an APR/native based connector. If the `PATH` (Windows) or `LD_LIBRARY_PATH` (on most unix systems) environment variables contain the Tomcat native library, the native/APR connector will be used. If the native library cannot be found, the Java based connector will be used.
> > To use an explicit protocol rather than rely on the auto-switching mechanism described above, the following values may be used:
> > `org.apache.coyote.ajp.AjpProtocol` - blocking Java connector
> > `org.apache.coyote.ajp.AjpAprProtocol` - the APR/native connector.
> > Custom implementations may also be used.

> > `proxyName` | If this Connector is being used in a proxy configuration, configure this attribute to specify the server name to be returned for calls to `request.getServerName()`. See Proxy Support for more information.
> > `proxyPort` | If this Connector is being used in a proxy configuration, configure this attribute to specify the server port to be returned for calls to `request.getServerPort()`. See Proxy Support for more information.
> > `redirectPort` | If this Connector is supporting non-SSL requests, and a request is received for which a matching `<security-constraint>` requires SSL transport, Catalina will automatically redirect the request to the port number specified here.
> > `scheme` | Set this attribute to the name of the protocol you wish to have returned by calls to `request.getScheme()`. For example, you would set this attribute to "`https`" for an SSL Connector. The default value is "`http`".
> > `secure` | Set this attribute to `true` if you wish to have calls to `request.isSecure()` to return `true` for requests received by this Connector. You would want this on an SSL Connector or a non SSL connector that is receiving data from a SSL accelerator, like a crypto card, a SSL appliance or even a webserver. The default value is `false`.
> > `URIEncoding` | This specifies the character encoding used to decode the URI bytes, after %xx decoding the URL. If not specified, ISO-8859-1 will be used.

> > `useBodyEncodingForURI`

> > This specifies if the encoding specified in contentType should be used for URI query parameters, instead of using the URIEncoding. This setting is present for compatibility with Tomcat 4.1.x, where the encoding specified in the contentType, or explicitly set using Request.setCharacterEncoding method was also used for the parameters from the URL. The default value is `false`.

> > `useIPVHosts` | Set this attribute to `true` to cause Tomcat to use the IP address passed by the native web server to determine the Host to send the request to. The default value is `false`.
> > `xpoweredBy` | Set this attribute to `true` to cause Tomcat to advertise support for the Servlet specification using the header recommended in the specification. The default value is `false`.

> Standard Implementations

> > To use AJP, you must specify the protocol attribute (see above).

> > These implementations support the AJP 1.3 protocol.

> > They support the following additional attributes (in addition to the common attributes listed above):

> > The BIO and APR/native implementations (there is no NIO implementation for APR) both support the following additional attributes in addition to the standard Connector attributes listed above:

> > Attribute | Description
> > --- | ---
> > `acceptCount` | The maximum queue length for incoming connection requests when all possible request processing threads are in use. Any requests received when the queue is full will be refused. The default value is 100.
> > `acceptorThreadCount` | The number of threads to be used to accept connections. Increase this value on a multi CPU machine, although you would never really need more than `2`. Also, with a lot of non keep alive connections, you might want to increase this value as well. Default value is `1`.
> > `address` | For servers with more than one IP address, this attribute specifies which address will be used for listening on the specified port. By default, this port will be used on all IP addresses associated with the server. A value of `127.0.0.1` indicates that the Connector will only listen on the loopback interface.
> > `connectionLinger` | The number of milliseconds during which the sockets used by this Connector will linger when they are closed. The default value `-1` which disables this option.
> > `connectionTimeout` | The number of milliseconds this Connector will wait, after accepting a connection, for the request URI line to be presented. The default value is 60000 (i.e. 60 seconds).
> > `executor` | A reference to the name in an Executor element. If this attribute is set, and the named executor exists, the connector will use the executor, and all the other thread attributes will be ignored. Note that if a shared executor is not specified for a connector then the connector will use a private, internal executor to provide the thread pool.
> > `keepAliveTimeout` | The number of milliseconds this Connector will wait for another AJP request before closing the connection. The default value is to use the value that has been set for the connectionTimeout attribute.

> > `maxThreads`

> > The maximum number of request processing threads to be created by this Connector, which therefore determines the maximum number of simultaneous requests that can be handled. If not specified, this attribute is set to 200. If an executor is associated with this connector, this attribute is ignored as the connector will execute tasks using the executor rather than an internal thread pool.

> > `minSpareThreads` | The minimum number of threads always kept running. If not specified, the default of `10` is used.
> > `packetSize` | This attribute sets the maximum AJP packet size in Bytes. The maximum value is 65536. It should be the same as the `max_packet_size` directive configured for mod_jk. Normally it is not necessary to change the maximum packet size. Problems with the default value have been reported when sending certificates or certificate chains. The default value is 8192.
> > `processorCache` | The protocol handler caches Processor objects to speed up performance. This setting dictates how many of these objects get cached. `-1` means unlimited, default is `200`. Set this value somewhere close to your maxThreads value.
> > `requiredSecret` | Only requests from workers with this secret keyword will be accepted.
> > `tcpNoDelay` | If set to `true`, the TCP_NO_DELAY option will be set on the server socket, which improves performance under most circumstances. This is set to `true` by default.
> > `threadPriority` | The priority of the request processing threads within the JVM. The default value is `java.lang.Thread#NORM_PRIORITY`. See the JavaDoc for the java.lang.Thread class for more details on what this priority means.
> > `tomcatAuthentication` | If set to `true`, the authentication will be done in Tomcat. Otherwise, the authenticated principal will be propagated from the native webserver and used for authorization in Tomcat. The default value is `true`.

> BIO specific configuration

> > The BIO implementation supports the following Java TCP socket attributes in addition to the common Connector and AJP attributes listed above.

> > Attribute | Description
> > --- | ---
> > `socket.rxBufSize` | (int)The socket receive buffer (SO_RCVBUF) size in bytes. JVM default used if not set.
> > `socket.txBufSize` | (int)The socket send buffer (SO_SNDBUF) size in bytes. JVM default used if not set.
> > `socket.tcpNoDelay` | (bool)This is equivalent to standard attribute tcpNoDelay.
> > `socket.soKeepAlive` | (bool)Boolean value for the socket's keep alive setting (SO_KEEPALIVE). JVM default used if not set.
> > `socket.ooBInline` | (bool)Boolean value for the socket OOBINLINE setting. JVM default used if not set.
> > `socket.soReuseAddress` | (bool)Boolean value for the sockets reuse address option (SO_REUSEADDR). JVM default used if not set.
> > `socket.soLingerOn` | (bool)Boolean value for the sockets so linger option (SO_LINGER). A value for the standard attribute connectionLinger that is >=0 is equivalent to setting this to `true`. A value for the standard attribute connectionLinger that is <0 is equivalent to setting this to `false`. Both this attribute and `soLingerTime` must be set else the JVM defaults will be used for both.
> > `socket.soLingerTime` | (int)Value in seconds for the sockets so linger option (SO_LINGER). This is equivalent to standard attribute connectionLinger. Both this attribute and `soLingerOn` must be set else the JVM defaults will be used for both.
> > `socket.soTimeout` | This is equivalent to standard attribute connectionTimeout.
> > `socket.soTrafficClass` | (byte)Value between `0` and `255` for the traffic class on the socket. JVM default used if not set. NoteOn some JDK versions, setting soTrafficClass causes a problem. A work around for this is to add the `-Djava.net.preferIPv4Stack=true` value to your JVM options.
> > `socket.performanceConnectionTime` | (int)The first value for the performance settings. See Socket Performance Options All three performance attributes must be set else the JVM defaults will be used for all three.
> > `socket.performanceLatency` | (int)The second value for the performance settings. See Socket Performance Options All three performance attributes must be set else the JVM defaults will be used for all three.
> > `socket.performanceBandwidth` | (int)The third value for the performance settings. See Socket Performance Options All three performance attributes must be set else the JVM defaults will be used for all three.
> > `socket.unlockTimeout` | (int) The timeout for a socket unlock. When a connector is stopped, it will try to release the acceptor thread by opening a connector to itself. The default value is `250` and the value is in milliseconds

> APR/native specific configuration

> > The APR/native implementation supports the following attributes in addition to the common Connector and AJP attributes listed above.

> > Attribute | Description
> > --- | ---
> > `pollTime` | Duration of a poll call. Lowering this value will slightly decrease latency of connections being kept alive in some cases, but will use more CPU as more poll calls are being made. The default value is 2000 (2ms).
> > `pollerSize` | Amount of sockets that the poller responsible for polling kept alive connections can hold at a given time. Extra connections will be closed right away. The default value is 8192, corresponding to 8192 keep-alive connections.

Nested Components

> None at this time.

Special Features

> Proxy Support

> > The `proxyName` and `proxyPort` attributes can be used when Tomcat is run behind a proxy server. These attributes modify the values returned to web applications that call the `request.getServerName()` and `request.getServerPort()` methods, which are often used to construct absolute URLs for redirects. Without configuring these attributes, the values returned would reflect the server name and port on which the connection from the proxy server was received, rather than the server name and port to whom the client directed the original request.

> > For more information, see the Proxy Support HOW-TO.

Copyright © 1999-2010, Apache Software Foundation